
;CodeVisionAVR C Compiler V2.04.5b Evaluation
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16
;Program type             : Application
;Clock frequency          : 16.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.5b Evaluation
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 5/25/2010
;Author  : Freeware, for evaluation and non-commercial use only
;Company :
;Comments:
;
;
;Chip type               : ATmega16
;Program type            : Application
;AVR Core Clock frequency: 16.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;#define ADC_VREF_TYPE 0x40
;#define F_CPU 16000000
;#include "lcd.h"
;//#include <util/delay.h>
;
;//char *str1,*str2;
;// Read the AD conversion result
;unsigned int read_adc(unsigned char adc_input)
; 0000 0024 {

	.CSEG
_read_adc:
; 0000 0025          ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
; 0000 0026          // Delay needed for the stabilization of the ADC input voltage
; 0000 0027          delay_us(10);
	__DELAY_USB 53
; 0000 0028          // Start the AD conversion
; 0000 0029          ADCSRA|=0x40;
	SBI  0x6,6
; 0000 002A          // Wait for the AD conversion to complete
; 0000 002B          while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
; 0000 002C          ADCSRA|=0x10;
	SBI  0x6,4
; 0000 002D          return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 002E }
;
;/*void LCD_init()
;{
;    LcdDATA_DDR |=  (1<<LcdD4)|(1<<LcdD5)|(1<<LcdD6)|(1<<LcdD7);    // setam pinii de date ca pini de iesire
;    LcdCMD_DDR  |=  (1<<LcdRS)|(1<<LcdRW)|(1<<LcdE);                // setam pinii de comenzi ca pini de iesire
;
;    LCD_waitNotBusy();
;
;    LcdCMD_PORT   &= ~(1<<LcdRS);                                    // Setam linia RS pe low
;    LcdCMD_PORT   &= ~(1<<LcdRW);                                    // Setam linia RW pe low (acum suntem in modul de trimis instructiuni)
;    LcdDATA_PORT  &= ~(1<<LcdD4)&~(1<<LcdD6)&~(1<<LcdD7);         // Specificam ca vrem 4 fire de date, prima comanda (LcdD5 activ, restul nu)
;    LcdDATA_PORT  |=  (1<<LcdD5);                                    // setam pinii de comenzi ca pini de iesire
;
;    LcdCMD_PORT |=  (1<<LcdE);                    // Setam linia E(nable) pe high; aceasta ii specifica LCD-ului sa preia datele
;    LCD_waitInstructions(12);                    // Asteptam o perioada de timp T
;    LcdCMD_PORT &= ~(1<<LcdE );                // Setam linia E(nable) pe low; transferul s-a terminat
;
;    LCD_writeInstruction(LCD_INSTR_4wire);         // Incarcam comanda: 4 bit data, 2 lines, 5x8 font
;    LCD_writeInstruction(LCD_INSTR_display);     // Display On, Cursor On, Blinking On
;    LCD_writeInstruction(0x06);                    // Increment, no shift
;    LCD_writeInstruction(0x01);                    // Clear Display
;
;
;}
;
;void LCD_writeInstruction(unsigned char _instruction)
;{
;
;    LCD_waitNotBusy();                             // asteptam ca LCD-ul sa fie liber sa primeasca comenzile
;    RS_LOW();                                    // setam pinul RS pe low (low=instructiuni, high=date)
;    RW_LOW();                                    // setam pinul RW pe low (suntem in modul de comenzi acum)
;    LCD_write(_instruction);                    // apelam procedura ce trimite byte-ul pe firele de date
;}
;
;
;void LCD_writeData(unsigned char _data)
;{
;    LCD_waitNotBusy();                             // asteptam ca LCD-ul sa fie liber sa primeasca comenzile
;    RS_HIGH();                                    // setam pinul RS pe high (low=instructiuni, high=date)
;    RW_LOW();                                    // setam pinul RW pe low (suntem in modul de date acum)
;    LCD_write(_data);                            // apelam procedura ce trimite byte-ul pe firele de date
;
;}
;
;void LCD_write(unsigned char _byte)
;{
;    unsigned char _byte2;
;
;    _byte2 = _byte>>4;
;
;    LcdDATA_PORT &= ~(1<<LcdD4);
;    if ( bit_is_set( _byte2, 0 ) )
;        LcdDATA_PORT |= (1<<LcdD4);
;
;    LcdDATA_PORT &= ~(1<<LcdD5);
;    if ( bit_is_set( _byte2, 1 ) )
;        LcdDATA_PORT |= (1<<LcdD5);
;
;    LcdDATA_PORT &= ~(1<<LcdD6);
;    if ( bit_is_set( _byte2, 2 ) )
;        LcdDATA_PORT |= (1<<LcdD6);
;
;    LcdDATA_PORT &= ~(1<<LcdD7);
;    if ( bit_is_set( _byte2, 3 ) )
;        LcdDATA_PORT |= (1<<LcdD7);
;
;    LcdCMD_PORT |= (1<<LcdE);                        // Setam Pinul E pe high
;    LCD_waitInstructions(12);                        // Asteptam o perioada de timp T
;    LcdCMD_PORT &= ~(1<<LcdE);                        // Setam Pinul E pe low
;
;    LCD_waitInstructions(12);                        // Asteptam o perioada de timp T
;
;    LcdDATA_PORT &= ~(1<<LcdD4);
;    if ( bit_is_set( _byte, 0 ) )
;        LcdDATA_PORT |= (1<<LcdD4);
;
;    LcdDATA_PORT &= ~(1<<LcdD5);
;    if ( bit_is_set( _byte, 1 ) )
;        LcdDATA_PORT |= (1<<LcdD5);
;
;    LcdDATA_PORT &= ~(1<<LcdD6);
;    if ( bit_is_set( _byte, 2 ) )
;        LcdDATA_PORT |= (1<<LcdD6);
;
;    LcdDATA_PORT &= ~(1<<LcdD7);
;    if ( bit_is_set( _byte, 3 ) )
;        LcdDATA_PORT |= (1<<LcdD7);
;
;    LcdCMD_PORT |= (1<<LcdE);                        // Setam Pinul E pe high
;    LCD_waitInstructions(12);                        // Asteptam o perioada de timp T
;    LcdCMD_PORT &= ~(1<<LcdE);                        // Setam Pinul E pe low
;    LCD_waitInstructions(12);
;}
;
;void LCD_waitNotBusy()
;{
;_delay_ms(10);
;}
;
;void LCD_waitInstructions(unsigned char _instructions)
;{
;    while (_instructions--)
;        ;
;}
;
;
;void LCD_printDecimal2u(unsigned int _n)
;{
;    unsigned char tmp=0;
;
;    // Extragem sutele
;    while(_n>=100)
;        _n-=100;
;
;    while(_n>=10){
;        tmp++;
;        _n-=10;
;    }
;
;    LCD_writeData(tmp+'0');
;    LCD_writeData(_n+'0');
;}
;
;void LCD_printHexa(unsigned int _n)
;{
;    unsigned char _tmp = _n>>4;
;    if (_tmp>9)
;        _tmp += 'A'-10;
;    else
;        _tmp += '0';
;    LCD_writeData( _tmp );
;    _tmp = _n & 0x0F;
;    if (_tmp>9)
;        _tmp += 'A'-10;
;    else
;        _tmp += '0';
;    LCD_writeData( _tmp );
;}
;
;
;void LCD_print(char* _msg)
;{
;    unsigned char i=0;
;    for( ; _msg[i]!=0 && i<16; i++)
;        LCD_writeData( _msg[i] );
;}
;
;void LCD_print2(char* _msg1, char* _msg2)
;{
;    LCD_writeInstruction(LCD_INSTR_clearDisplay);
;    LCD_print(_msg1);
;    LCD_writeInstruction(LCD_INSTR_nextLine);
;    LCD_print(_msg2);
;}            */
;
;
;void buzz(unsigned int s,int c1,int c2)
; 0000 00CC {
_buzz:
; 0000 00CD      int i,j;
; 0000 00CE     if (s>=0&&s<12)
	CALL __SAVELOCR4
;	s -> Y+8
;	c1 -> Y+6
;	c2 -> Y+4
;	i -> R16,R17
;	j -> R18,R19
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,0
	BRLO _0x7
	SBIW R26,12
	BRLO _0x8
_0x7:
	RJMP _0x6
_0x8:
; 0000 00CF     {
; 0000 00D0          PORTB=0b00000111;
	LDI  R30,LOW(7)
	OUT  0x18,R30
; 0000 00D1          while(s>=0&&s<12)
_0x9:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,0
	BRLO _0xC
	SBIW R26,12
	BRLO _0xD
_0xC:
	RJMP _0xB
_0xD:
; 0000 00D2          {
; 0000 00D3              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 00D4              delay_ms(100);
	RCALL SUBOPT_0x1
; 0000 00D5              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 00D6              delay_ms(100);
	RCALL SUBOPT_0x1
; 0000 00D7              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 00D8              /*if(c1==16)
; 0000 00D9              {
; 0000 00DA                   if(c2==16)
; 0000 00DB                   {
; 0000 00DC                        for(i=0;i<16;i++)
; 0000 00DD                             str1[i]=str1[i+1];
; 0000 00DE                        c1--;
; 0000 00DF                        str1[c1]=str2[0];
; 0000 00E0                        for(j=0;j<16;j++)
; 0000 00E1                             str2[j]=str2[j+1];
; 0000 00E2                        c2--;
; 0000 00E3 
; 0000 00E4                   }
; 0000 00E5 
; 0000 00E6                   else if(c2<16)
; 0000 00E7                   {
; 0000 00E8                        str2[c2]=(char)s;
; 0000 00E9                        LCD_print2(str1,str2);
; 0000 00EA                        c2++;
; 0000 00EB                   }
; 0000 00EC              }
; 0000 00ED 
; 0000 00EE              else if(c1<16)
; 0000 00EF              {
; 0000 00F0                       str1[c1]=(char)s;
; 0000 00F1                       LCD_print(str1);
; 0000 00F2                       c1++;
; 0000 00F3              } */
; 0000 00F4          }
	RJMP _0x9
_0xB:
; 0000 00F5     }
; 0000 00F6 
; 0000 00F7     else if(s>=12&&s<24)
	RJMP _0xE
_0x6:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,12
	BRLO _0x10
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,24
	BRLO _0x11
_0x10:
	RJMP _0xF
_0x11:
; 0000 00F8     {
; 0000 00F9          PORTB=0b00000110;
	LDI  R30,LOW(6)
	OUT  0x18,R30
; 0000 00FA          while(s>=12&&s<24)
_0x12:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,12
	BRLO _0x15
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,24
	BRLO _0x16
_0x15:
	RJMP _0x14
_0x16:
; 0000 00FB          {
; 0000 00FC              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 00FD              delay_ms(200);
	RCALL SUBOPT_0x4
; 0000 00FE              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 00FF              delay_ms(200);
	RCALL SUBOPT_0x4
; 0000 0100              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 0101              /*if(c1==16)
; 0000 0102              {
; 0000 0103                   if(c2==16)
; 0000 0104                   {
; 0000 0105                        for(i=0;i<16;i++)
; 0000 0106                             str1[i]=str1[i+1];
; 0000 0107                        c1--;
; 0000 0108                        str1[c1]=str2[0];
; 0000 0109                        for(j=0;j<16;j++)
; 0000 010A                             str2[j]=str2[j+1];
; 0000 010B                        c2--;
; 0000 010C 
; 0000 010D                   }
; 0000 010E 
; 0000 010F                   else if(c2<16)
; 0000 0110                   {
; 0000 0111                        str2[c2]=(char)s;
; 0000 0112                        LCD_print2(str1,str2);
; 0000 0113                        c2++;
; 0000 0114                   }
; 0000 0115              }
; 0000 0116 
; 0000 0117              else if(c1<16)
; 0000 0118              {
; 0000 0119                       str1[c1]=(char)s;
; 0000 011A                       LCD_print(str1);
; 0000 011B                       c1++;
; 0000 011C              }*/
; 0000 011D          }
	RJMP _0x12
_0x14:
; 0000 011E     }
; 0000 011F 
; 0000 0120     else if(s>=24&&s<40)
	RJMP _0x17
_0xF:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,24
	BRLO _0x19
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,40
	BRLO _0x1A
_0x19:
	RJMP _0x18
_0x1A:
; 0000 0121     {
; 0000 0122          PORTB=0b00000100;
	LDI  R30,LOW(4)
	OUT  0x18,R30
; 0000 0123          while(s>=24&&s<40)
_0x1B:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,24
	BRLO _0x1E
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,40
	BRLO _0x1F
_0x1E:
	RJMP _0x1D
_0x1F:
; 0000 0124          {
; 0000 0125              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 0126              delay_ms(300);
	RCALL SUBOPT_0x5
; 0000 0127              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 0128              delay_ms(300);
	RCALL SUBOPT_0x5
; 0000 0129              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 012A              /*if(c1==16)
; 0000 012B              {
; 0000 012C                   if(c2==16)
; 0000 012D                   {
; 0000 012E                        for(i=0;i<16;i++)
; 0000 012F                             str1[i]=str1[i+1];
; 0000 0130                        c1--;
; 0000 0131                        str1[c1]=str2[0];
; 0000 0132                        for(j=0;j<16;j++)
; 0000 0133                             str2[j]=str2[j+1];
; 0000 0134                        c2--;
; 0000 0135 
; 0000 0136                   }
; 0000 0137 
; 0000 0138                   else if(c2<16)
; 0000 0139                   {
; 0000 013A                        str2[c2]=(char)s;
; 0000 013B                        LCD_print2(str1,str2);
; 0000 013C                        c2++;
; 0000 013D                   }
; 0000 013E              }
; 0000 013F 
; 0000 0140              else if(c1<16)
; 0000 0141              {
; 0000 0142                       str1[c1]=(char)s;
; 0000 0143                       LCD_print(str1);
; 0000 0144                       c1++;
; 0000 0145              } */
; 0000 0146          }
	RJMP _0x1B
_0x1D:
; 0000 0147     }
; 0000 0148 
; 0000 0149     else if(s>=40&&s<60)
	RJMP _0x20
_0x18:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,40
	BRLO _0x22
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,60
	BRLO _0x23
_0x22:
	RJMP _0x21
_0x23:
; 0000 014A     {
; 0000 014B          PORTB=0b00111000;
	LDI  R30,LOW(56)
	OUT  0x18,R30
; 0000 014C         while(s>=40&&s<60)
_0x24:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,40
	BRLO _0x27
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,60
	BRLO _0x28
_0x27:
	RJMP _0x26
_0x28:
; 0000 014D          {
; 0000 014E              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 014F              delay_ms(500);
	RCALL SUBOPT_0x6
; 0000 0150              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 0151              delay_ms(500);
	RCALL SUBOPT_0x6
; 0000 0152              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 0153              /*if(c1==16)
; 0000 0154              {
; 0000 0155                   if(c2==16)
; 0000 0156                   {
; 0000 0157                        for(i=0;i<16;i++)
; 0000 0158                             str1[i]=str1[i+1];
; 0000 0159                        c1--;
; 0000 015A                        str1[c1]=str2[0];
; 0000 015B                        for(j=0;j<16;j++)
; 0000 015C                             str2[j]=str2[j+1];
; 0000 015D                        c2--;
; 0000 015E 
; 0000 015F                   }
; 0000 0160 
; 0000 0161                   else if(c2<16)
; 0000 0162                   {
; 0000 0163                        str2[c2]=(char)s;
; 0000 0164                        LCD_print2(str1,str2);
; 0000 0165                        c2++;
; 0000 0166                   }
; 0000 0167              }
; 0000 0168 
; 0000 0169              else if(c1<16)
; 0000 016A              {
; 0000 016B                       str1[c1]=(char)s;
; 0000 016C                       LCD_print(str1);
; 0000 016D                       c1++;
; 0000 016E              } */
; 0000 016F          }
	RJMP _0x24
_0x26:
; 0000 0170     }
; 0000 0171 
; 0000 0172     else if(s>=60&&s<84)
	RJMP _0x29
_0x21:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,60
	BRLO _0x2B
	RCALL SUBOPT_0x7
	BRLO _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
; 0000 0173     {
; 0000 0174          PORTB=0b00110000;
	LDI  R30,LOW(48)
	OUT  0x18,R30
; 0000 0175          while(s>=60&&s<84)
_0x2D:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,60
	BRLO _0x30
	RCALL SUBOPT_0x7
	BRLO _0x31
_0x30:
	RJMP _0x2F
_0x31:
; 0000 0176          {
; 0000 0177              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 0178              delay_ms(700);
	RCALL SUBOPT_0x8
; 0000 0179              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 017A              delay_ms(700);
	RCALL SUBOPT_0x8
; 0000 017B              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 017C              /*if(c1==16)
; 0000 017D              {
; 0000 017E                   if(c2==16)
; 0000 017F                   {
; 0000 0180                        for(i=0;i<16;i++)
; 0000 0181                             str1[i]=str1[i+1];
; 0000 0182                        c1--;
; 0000 0183                        str1[c1]=str2[0];
; 0000 0184                        for(j=0;j<16;j++)
; 0000 0185                             str2[j]=str2[j+1];
; 0000 0186                        c2--;
; 0000 0187 
; 0000 0188                   }
; 0000 0189 
; 0000 018A                   else if(c2<16)
; 0000 018B                   {
; 0000 018C                        str2[c2]=(char)s;
; 0000 018D                        LCD_print2(str1,str2);
; 0000 018E                        c2++;
; 0000 018F                   }
; 0000 0190              }
; 0000 0191 
; 0000 0192              else if(c1<16)
; 0000 0193              {
; 0000 0194                       str1[c1]=(char)s;
; 0000 0195                       LCD_print(str1);
; 0000 0196                       c1++;
; 0000 0197              } */
; 0000 0198          }
	RJMP _0x2D
_0x2F:
; 0000 0199     }
; 0000 019A 
; 0000 019B     else if(s>=84&&s<112)
	RJMP _0x32
_0x2A:
	RCALL SUBOPT_0x7
	BRLO _0x34
	RCALL SUBOPT_0x9
	BRLO _0x35
_0x34:
	RJMP _0x33
_0x35:
; 0000 019C     {
; 0000 019D          PORTB=0b00100000;
	LDI  R30,LOW(32)
	OUT  0x18,R30
; 0000 019E          while(s>=84&&s<112)
_0x36:
	RCALL SUBOPT_0x7
	BRLO _0x39
	RCALL SUBOPT_0x9
	BRLO _0x3A
_0x39:
	RJMP _0x38
_0x3A:
; 0000 019F          {
; 0000 01A0              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 01A1              delay_ms(900);
	RCALL SUBOPT_0xA
; 0000 01A2              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 01A3              delay_ms(900);
	RCALL SUBOPT_0xA
; 0000 01A4              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 01A5              /*if(c1==16)
; 0000 01A6              {
; 0000 01A7                   if(c2==16)
; 0000 01A8                   {
; 0000 01A9                        for(i=0;i<16;i++)
; 0000 01AA                             str1[i]=str1[i+1];
; 0000 01AB                        c1--;
; 0000 01AC                        str1[c1]=str2[0];
; 0000 01AD                        for(j=0;j<16;j++)
; 0000 01AE                             str2[j]=str2[j+1];
; 0000 01AF                        c2--;
; 0000 01B0 
; 0000 01B1                   }
; 0000 01B2 
; 0000 01B3                   else if(c2<16)
; 0000 01B4                   {
; 0000 01B5                        str2[c2]=(char)s;
; 0000 01B6                        LCD_print2(str1,str2);
; 0000 01B7                        c2++;
; 0000 01B8                   }
; 0000 01B9              }
; 0000 01BA 
; 0000 01BB              else if(c1<16)
; 0000 01BC              {
; 0000 01BD                       str1[c1]=(char)s;
; 0000 01BE                       LCD_print(str1);
; 0000 01BF                       c1++;
; 0000 01C0              } */
; 0000 01C1          }
	RJMP _0x36
_0x38:
; 0000 01C2     }
; 0000 01C3 
; 0000 01C4     else if(s>=112&&s<144)
	RJMP _0x3B
_0x33:
	RCALL SUBOPT_0x9
	BRLO _0x3D
	RCALL SUBOPT_0xB
	BRLO _0x3E
_0x3D:
	RJMP _0x3C
_0x3E:
; 0000 01C5     {
; 0000 01C6          PORTB=0b11000000;
	LDI  R30,LOW(192)
	OUT  0x18,R30
; 0000 01C7          while(s>=112&&s<144)
_0x3F:
	RCALL SUBOPT_0x9
	BRLO _0x42
	RCALL SUBOPT_0xB
	BRLO _0x43
_0x42:
	RJMP _0x41
_0x43:
; 0000 01C8          {
; 0000 01C9              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 01CA              delay_ms(1100);
	RCALL SUBOPT_0xC
; 0000 01CB              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 01CC              delay_ms(1100);
	RCALL SUBOPT_0xC
; 0000 01CD              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 01CE              /*if(c1==16)
; 0000 01CF              {
; 0000 01D0                   if(c2==16)
; 0000 01D1                   {
; 0000 01D2                        for(i=0;i<16;i++)
; 0000 01D3                             str1[i]=str1[i+1];
; 0000 01D4                        c1--;
; 0000 01D5                        str1[c1]=str2[0];
; 0000 01D6                        for(j=0;j<16;j++)
; 0000 01D7                             str2[j]=str2[j+1];
; 0000 01D8                        c2--;
; 0000 01D9 
; 0000 01DA                   }
; 0000 01DB 
; 0000 01DC                   else if(c2<16)
; 0000 01DD                   {
; 0000 01DE                        str2[c2]=(char)s;
; 0000 01DF                        LCD_print2(str1,str2);
; 0000 01E0                        c2++;
; 0000 01E1                   }
; 0000 01E2              }
; 0000 01E3 
; 0000 01E4              else if(c1<16)
; 0000 01E5              {
; 0000 01E6                       str1[c1]=(char)s;
; 0000 01E7                       LCD_print(str1);
; 0000 01E8                       c1++;
; 0000 01E9              } */
; 0000 01EA          }
	RJMP _0x3F
_0x41:
; 0000 01EB     }
; 0000 01EC 
; 0000 01ED     else if(s>=144&&s<176)
	RJMP _0x44
_0x3C:
	RCALL SUBOPT_0xB
	BRLO _0x46
	RCALL SUBOPT_0xD
	BRLO _0x47
_0x46:
	RJMP _0x45
_0x47:
; 0000 01EE     {
; 0000 01EF          PORTB=0b10000000;
	LDI  R30,LOW(128)
	OUT  0x18,R30
; 0000 01F0          while(s>=144&&s<176)
_0x48:
	RCALL SUBOPT_0xB
	BRLO _0x4B
	RCALL SUBOPT_0xD
	BRLO _0x4C
_0x4B:
	RJMP _0x4A
_0x4C:
; 0000 01F1          {
; 0000 01F2              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 01F3              delay_ms(1300);
	RCALL SUBOPT_0xE
; 0000 01F4              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 01F5              delay_ms(1300);
	RCALL SUBOPT_0xE
; 0000 01F6              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 01F7              /*if(c1==16)
; 0000 01F8              {
; 0000 01F9                   if(c2==16)
; 0000 01FA                   {
; 0000 01FB                        for(i=0;i<16;i++)
; 0000 01FC                             str1[i]=str1[i+1];
; 0000 01FD                        c1--;
; 0000 01FE                        str1[c1]=str2[0];
; 0000 01FF                        for(j=0;j<16;j++)
; 0000 0200                             str2[j]=str2[j+1];
; 0000 0201                        c2--;
; 0000 0202 
; 0000 0203                   }
; 0000 0204 
; 0000 0205                   else if(c2<16)
; 0000 0206                   {
; 0000 0207                        str2[c2]=(char)s;
; 0000 0208                        LCD_print2(str1,str2);
; 0000 0209                        c2++;
; 0000 020A                   }
; 0000 020B              }
; 0000 020C 
; 0000 020D              else if(c1<16)
; 0000 020E              {
; 0000 020F                       str1[c1]=(char)s;
; 0000 0210                       LCD_print(str1);
; 0000 0211                       c1++;
; 0000 0212              } */
; 0000 0213          }
	RJMP _0x48
_0x4A:
; 0000 0214     }
; 0000 0215 
; 0000 0216     else if(s>=176)
	RJMP _0x4D
_0x45:
	RCALL SUBOPT_0xD
	BRLO _0x4E
; 0000 0217     {
; 0000 0218          PORTB=0b00000000;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0219          while(s>=250)
_0x4F:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0xFA)
	LDI  R30,HIGH(0xFA)
	CPC  R27,R30
	BRLO _0x51
; 0000 021A          {
; 0000 021B              OCR1A=10;
	RCALL SUBOPT_0x0
; 0000 021C              delay_ms(1500);
	RCALL SUBOPT_0xF
; 0000 021D              OCR1A=0;
	RCALL SUBOPT_0x2
; 0000 021E              delay_ms(1500);
	RCALL SUBOPT_0xF
; 0000 021F              s=read_adc(0);
	RCALL SUBOPT_0x3
; 0000 0220              /*if(c1==16)
; 0000 0221              {
; 0000 0222                   if(c2==16)
; 0000 0223                   {
; 0000 0224                        for(i=0;i<16;i++)
; 0000 0225                             str1[i]=str1[i+1];
; 0000 0226                        c1--;
; 0000 0227                        str1[c1]=str2[0];
; 0000 0228                        for(j=0;j<16;j++)
; 0000 0229                             str2[j]=str2[j+1];
; 0000 022A                        c2--;
; 0000 022B 
; 0000 022C                   }
; 0000 022D 
; 0000 022E                   else if(c2<16)
; 0000 022F                   {
; 0000 0230                        str2[c2]=(char)s;
; 0000 0231                        LCD_print2(str1,str2);
; 0000 0232                        c2++;
; 0000 0233                   }
; 0000 0234              }
; 0000 0235 
; 0000 0236              else if(c1<16)
; 0000 0237              {
; 0000 0238                       str1[c1]=(char)s;
; 0000 0239                       LCD_print(str1);
; 0000 023A                       c1++;
; 0000 023B              }
; 0000 023C          }*/
; 0000 023D     }
	RJMP _0x4F
_0x51:
; 0000 023E }
; 0000 023F }
_0x4E:
_0x4D:
_0x44:
_0x3B:
_0x32:
_0x29:
_0x20:
_0x17:
_0xE:
	CALL __LOADLOCR4
	ADIW R28,10
	RET
;
;
;// Declare your global variables here
;
;void main(void)
; 0000 0245 {
_main:
; 0000 0246 // Declare your local variables here
; 0000 0247    int contor1=0,contor2=0;
; 0000 0248    unsigned int s;
; 0000 0249 // Input/Output Ports initialization
; 0000 024A // Port A initialization
; 0000 024B // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 024C // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 024D    PORTA=0x00;
;	contor1 -> R16,R17
;	contor2 -> R18,R19
;	s -> R20,R21
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 024E    DDRA=0x00;
	OUT  0x1A,R30
; 0000 024F 
; 0000 0250 // Port B initialization
; 0000 0251 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0252 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0253    PORTB=0x00;
	OUT  0x18,R30
; 0000 0254    DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0255 
; 0000 0256 // Port C initialization
; 0000 0257 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0258 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0259    PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 025A    DDRC=0x00;
	OUT  0x14,R30
; 0000 025B 
; 0000 025C // Port D initialization
; 0000 025D // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 025E // State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 025F    PORTD=0x00;
	OUT  0x12,R30
; 0000 0260    DDRD=0x30;
	LDI  R30,LOW(48)
	OUT  0x11,R30
; 0000 0261 
; 0000 0262 // Timer/Counter 0 initialization
; 0000 0263 // Clock source: System Clock
; 0000 0264 // Clock value: Timer 0 Stopped
; 0000 0265 // Mode: Normal top=FFh
; 0000 0266 // OC0 output: Disconnected
; 0000 0267    TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0268    TCNT0=0x00;
	OUT  0x32,R30
; 0000 0269    OCR0=0x00;
	OUT  0x3C,R30
; 0000 026A 
; 0000 026B // Timer/Counter 1 initialization
; 0000 026C // Clock source: System Clock
; 0000 026D // Clock value: 250.000 kHz
; 0000 026E // Mode: Ph. correct PWM top=00FFh
; 0000 026F // OC1A output: Non-Inv.
; 0000 0270 // OC1B output: Non-Inv.
; 0000 0271 // Noise Canceler: Off
; 0000 0272 // Input Capture on Falling Edge
; 0000 0273 // Timer1 Overflow Interrupt: Off
; 0000 0274 // Input Capture Interrupt: Off
; 0000 0275 // Compare A Match Interrupt: Off
; 0000 0276 // Compare B Match Interrupt: Off
; 0000 0277    TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
; 0000 0278    TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
; 0000 0279    TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 027A    TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 027B 
; 0000 027C    ICR1H=255;
	LDI  R30,LOW(255)
	OUT  0x27,R30
; 0000 027D    ICR1L=255;
	OUT  0x26,R30
; 0000 027E 
; 0000 027F 
; 0000 0280 
; 0000 0281    OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 0282    OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0283 
; 0000 0284 // Timer/Counter 2 initialization
; 0000 0285 // Clock source: System Clock
; 0000 0286 // Clock value: Timer2 Stopped
; 0000 0287 // Mode: Normal top=FFh
; 0000 0288 // OC2 output: Disconnected
; 0000 0289    ASSR=0x00;
	OUT  0x22,R30
; 0000 028A    TCCR2=0x00;
	OUT  0x25,R30
; 0000 028B    TCNT2=0x00;
	OUT  0x24,R30
; 0000 028C    OCR2=0x00;
	OUT  0x23,R30
; 0000 028D 
; 0000 028E // External Interrupt(s) initialization
; 0000 028F // INT0: Off
; 0000 0290 // INT1: Off
; 0000 0291 // INT2: Off
; 0000 0292    MCUCR=0x00;
	OUT  0x35,R30
; 0000 0293    MCUCSR=0x00;
	OUT  0x34,R30
; 0000 0294 
; 0000 0295 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0296    TIMSK=0x00;
	OUT  0x39,R30
; 0000 0297 
; 0000 0298 // Analog Comparator initialization
; 0000 0299 // Analog Comparator: Off
; 0000 029A // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 029B    ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 029C    SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 029D 
; 0000 029E // ADC initialization
; 0000 029F // ADC Clock frequency: 250.000 kHz
; 0000 02A0 // ADC Voltage Reference: AVCC pin
; 0000 02A1 // ADC Auto Trigger Source: ADC Stopped
; 0000 02A2    ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	OUT  0x7,R30
; 0000 02A3    ADCSRA=0x86;
	LDI  R30,LOW(134)
	OUT  0x6,R30
; 0000 02A4    //str1=(char*)malloc(16*sizeof(char));
; 0000 02A5    //str1=(char*)malloc(16*sizeof(char));
; 0000 02A6    //LCD_init();
; 0000 02A7    //LCD_print("start");
; 0000 02A8    s=read_adc(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R20,R30
; 0000 02A9    //str1[contor1]=(char)s;
; 0000 02AA    while (1)
_0x52:
; 0000 02AB    {
; 0000 02AC     // Place your code here
; 0000 02AD        buzz(s,contor1,contor2);
	ST   -Y,R21
	ST   -Y,R20
	ST   -Y,R17
	ST   -Y,R16
	ST   -Y,R19
	ST   -Y,R18
	RCALL _buzz
; 0000 02AE        s=read_adc(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R20,R30
; 0000 02AF    };
	RJMP _0x52
; 0000 02B0 }
_0x55:
	RJMP _0x55

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x54)
	LDI  R30,HIGH(0x54)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x70)
	LDI  R30,HIGH(0x70)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(900)
	LDI  R31,HIGH(900)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xB:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x90)
	LDI  R30,HIGH(0x90)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(1100)
	LDI  R31,HIGH(1100)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0xB0)
	LDI  R30,HIGH(0xB0)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(1300)
	LDI  R31,HIGH(1300)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
