/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.5b Evaluation
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 5/25/2010
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 16.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>

#include <delay.h>

#define ADC_VREF_TYPE 0x40
#define F_CPU 16000000
#include "lcd.h"
//#include <util/delay.h>

//char *str1,*str2;
// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
         ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
         // Delay needed for the stabilization of the ADC input voltage
         delay_us(10);
         // Start the AD conversion
         ADCSRA|=0x40;
         // Wait for the AD conversion to complete
         while ((ADCSRA & 0x10)==0);
         ADCSRA|=0x10;
         return ADCW;
}

/*void LCD_init()
{
    LcdDATA_DDR |=  (1<<LcdD4)|(1<<LcdD5)|(1<<LcdD6)|(1<<LcdD7);    // setam pinii de date ca pini de iesire
    LcdCMD_DDR  |=  (1<<LcdRS)|(1<<LcdRW)|(1<<LcdE);                // setam pinii de comenzi ca pini de iesire

    LCD_waitNotBusy();
    
    LcdCMD_PORT   &= ~(1<<LcdRS);                                    // Setam linia RS pe low
    LcdCMD_PORT   &= ~(1<<LcdRW);                                    // Setam linia RW pe low (acum suntem in modul de trimis instructiuni)
    LcdDATA_PORT  &= ~(1<<LcdD4)&~(1<<LcdD6)&~(1<<LcdD7);         // Specificam ca vrem 4 fire de date, prima comanda (LcdD5 activ, restul nu)
    LcdDATA_PORT  |=  (1<<LcdD5);                                    // setam pinii de comenzi ca pini de iesire
    
    LcdCMD_PORT |=  (1<<LcdE);                    // Setam linia E(nable) pe high; aceasta ii specifica LCD-ului sa preia datele
    LCD_waitInstructions(12);                    // Asteptam o perioada de timp T
    LcdCMD_PORT &= ~(1<<LcdE );                // Setam linia E(nable) pe low; transferul s-a terminat

    LCD_writeInstruction(LCD_INSTR_4wire);         // Incarcam comanda: 4 bit data, 2 lines, 5x8 font
    LCD_writeInstruction(LCD_INSTR_display);     // Display On, Cursor On, Blinking On
    LCD_writeInstruction(0x06);                    // Increment, no shift
    LCD_writeInstruction(0x01);                    // Clear Display

    
}

void LCD_writeInstruction(unsigned char _instruction)
{            
    
    LCD_waitNotBusy();                             // asteptam ca LCD-ul sa fie liber sa primeasca comenzile    
    RS_LOW();                                    // setam pinul RS pe low (low=instructiuni, high=date)
    RW_LOW();                                    // setam pinul RW pe low (suntem in modul de comenzi acum)
    LCD_write(_instruction);                    // apelam procedura ce trimite byte-ul pe firele de date
}


void LCD_writeData(unsigned char _data)
{
    LCD_waitNotBusy();                             // asteptam ca LCD-ul sa fie liber sa primeasca comenzile    
    RS_HIGH();                                    // setam pinul RS pe high (low=instructiuni, high=date)
    RW_LOW();                                    // setam pinul RW pe low (suntem in modul de date acum)
    LCD_write(_data);                            // apelam procedura ce trimite byte-ul pe firele de date

}

void LCD_write(unsigned char _byte)
{
    unsigned char _byte2;
    
    _byte2 = _byte>>4;

    LcdDATA_PORT &= ~(1<<LcdD4);
    if ( bit_is_set( _byte2, 0 ) )
        LcdDATA_PORT |= (1<<LcdD4);
        
    LcdDATA_PORT &= ~(1<<LcdD5);
    if ( bit_is_set( _byte2, 1 ) )
        LcdDATA_PORT |= (1<<LcdD5);

    LcdDATA_PORT &= ~(1<<LcdD6);
    if ( bit_is_set( _byte2, 2 ) )
        LcdDATA_PORT |= (1<<LcdD6);

    LcdDATA_PORT &= ~(1<<LcdD7);
    if ( bit_is_set( _byte2, 3 ) )
        LcdDATA_PORT |= (1<<LcdD7);

    LcdCMD_PORT |= (1<<LcdE);                        // Setam Pinul E pe high
    LCD_waitInstructions(12);                        // Asteptam o perioada de timp T
    LcdCMD_PORT &= ~(1<<LcdE);                        // Setam Pinul E pe low

    LCD_waitInstructions(12);                        // Asteptam o perioada de timp T
    
    LcdDATA_PORT &= ~(1<<LcdD4);
    if ( bit_is_set( _byte, 0 ) )
        LcdDATA_PORT |= (1<<LcdD4);
    
    LcdDATA_PORT &= ~(1<<LcdD5);
    if ( bit_is_set( _byte, 1 ) )
        LcdDATA_PORT |= (1<<LcdD5);

    LcdDATA_PORT &= ~(1<<LcdD6);
    if ( bit_is_set( _byte, 2 ) )
        LcdDATA_PORT |= (1<<LcdD6);

    LcdDATA_PORT &= ~(1<<LcdD7);
    if ( bit_is_set( _byte, 3 ) )
        LcdDATA_PORT |= (1<<LcdD7);

    LcdCMD_PORT |= (1<<LcdE);                        // Setam Pinul E pe high
    LCD_waitInstructions(12);                        // Asteptam o perioada de timp T
    LcdCMD_PORT &= ~(1<<LcdE);                        // Setam Pinul E pe low
    LCD_waitInstructions(12);
}

void LCD_waitNotBusy()
{
_delay_ms(10);
}

void LCD_waitInstructions(unsigned char _instructions)
{
    while (_instructions--)
        ;
}


void LCD_printDecimal2u(unsigned int _n)
{
    unsigned char tmp=0;
    
    // Extragem sutele
    while(_n>=100)
        _n-=100;

    while(_n>=10){
        tmp++;
        _n-=10;
    }

    LCD_writeData(tmp+'0');
    LCD_writeData(_n+'0');
}

void LCD_printHexa(unsigned int _n)
{
    unsigned char _tmp = _n>>4;
    if (_tmp>9)
        _tmp += 'A'-10;
    else
        _tmp += '0';
    LCD_writeData( _tmp );
    _tmp = _n & 0x0F;
    if (_tmp>9)
        _tmp += 'A'-10;
    else
        _tmp += '0';
    LCD_writeData( _tmp );
}


void LCD_print(char* _msg)
{
    unsigned char i=0;
    for( ; _msg[i]!=0 && i<16; i++)
        LCD_writeData( _msg[i] );
}

void LCD_print2(char* _msg1, char* _msg2)
{
    LCD_writeInstruction(LCD_INSTR_clearDisplay);
    LCD_print(_msg1);
    LCD_writeInstruction(LCD_INSTR_nextLine);
    LCD_print(_msg2);
}            */


void buzz(unsigned int s,int c1,int c2)
{
     int i,j;
    if (s>=0&&s<12)  
    { 
         PORTB=0b00000111;  
         while(s>=0&&s<12)
         {
             OCR1A=10;
             delay_ms(100);
             OCR1A=0;
             delay_ms(100);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    }  
         
    else if(s>=12&&s<24)
    { 
         PORTB=0b00000110; 
         while(s>=12&&s<24)
         {
             OCR1A=10;
             delay_ms(200);
             OCR1A=0;
             delay_ms(200);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             }*/ 
         }
    }
    
    else if(s>=24&&s<40)
    {
         PORTB=0b00000100;
         while(s>=24&&s<40)
         {
             OCR1A=10;
             delay_ms(300);
             OCR1A=0;
             delay_ms(300);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    }
             
    else if(s>=40&&s<60)
    {
         PORTB=0b00111000;
        while(s>=40&&s<60)
         {
             OCR1A=10;
             delay_ms(500);
             OCR1A=0;
             delay_ms(500);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    }  
                
    else if(s>=60&&s<84)
    {
         PORTB=0b00110000; 
         while(s>=60&&s<84)
         {
             OCR1A=10;
             delay_ms(700);
             OCR1A=0;
             delay_ms(700);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    } 
              
    else if(s>=84&&s<112)
    {
         PORTB=0b00100000;
         while(s>=84&&s<112)
         {
             OCR1A=10;
             delay_ms(900);
             OCR1A=0;
             delay_ms(900);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    }  
               
    else if(s>=112&&s<144)
    {
         PORTB=0b11000000;
         while(s>=112&&s<144)
         {
             OCR1A=10;
             delay_ms(1100);
             OCR1A=0;
             delay_ms(1100);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    }
                
    else if(s>=144&&s<176)
    {
         PORTB=0b10000000; 
         while(s>=144&&s<176)
         {
             OCR1A=10;
             delay_ms(1300);
             OCR1A=0;
             delay_ms(1300);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } */
         }
    } 
                   
    else if(s>=176)
    {
         PORTB=0b00000000;   
         while(s>=250)
         {
             OCR1A=10;
             delay_ms(1500);
             OCR1A=0;
             delay_ms(1500);
             s=read_adc(0);
             /*if(c1==16)
             {
                  if(c2==16)
                  {
                       for(i=0;i<16;i++)
                            str1[i]=str1[i+1];
                       c1--;
                       str1[c1]=str2[0];
                       for(j=0;j<16;j++)
                            str2[j]=str2[j+1];
                       c2--;
                      
                  }
                  
                  else if(c2<16)
                  {
                       str2[c2]=(char)s;
                       LCD_print2(str1,str2);
                       c2++;
                  }
             }
             
             else if(c1<16)
             {
                      str1[c1]=(char)s;
                      LCD_print(str1);
                      c1++;
             } 
         }*/
        }
    }
}


// Declare your global variables here
     
void main(void)
{
// Declare your local variables here
   int contor1=0,contor2=0;
   unsigned int s;
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
   PORTA=0x00;
   DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
   PORTB=0x00;
   DDRB=0xFF;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
   PORTC=0x00;
   DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
   PORTD=0x00;
   DDRD=0x30;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
   TCCR0=0x00;
   TCNT0=0x00;
   OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 250.000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
   TCCR1A=0xA1;
   TCCR1B=0x03;
   TCNT1H=0x00;
   TCNT1L=0x00;

   ICR1H=255;
   ICR1L=255;



   OCR1BH=0x00;
   OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
   ASSR=0x00;
   TCCR2=0x00;
   TCNT2=0x00;
   OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
   MCUCR=0x00;
   MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
   TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
   ACSR=0x80;
   SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 250.000 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: ADC Stopped
   ADMUX=ADC_VREF_TYPE & 0xff;
   ADCSRA=0x86;
   //str1=(char*)malloc(16*sizeof(char));
   //str1=(char*)malloc(16*sizeof(char));
   //LCD_init();
   //LCD_print("start");
   s=read_adc(0);
   //str1[contor1]=(char)s;
   while (1)
   {
    // Place your code here 
       buzz(s,contor1,contor2); 
       s=read_adc(0);             
   };
}
